# W3Nest client
from w3nest_client.context import Context

# W3Nest
from w3nest.app.environment import Environment
from w3nest.app.projects import IPipelineFactory, JsBundle, Link, Pipeline

# CI
from w3nest.ci.ts_frontend import PipelineConfig, pipeline


class PipelineFactory(IPipelineFactory):

    def __init__(self, **kwargs):
        super().__init__(**kwargs)

    async def get(self, env: Environment, context: Context) -> Pipeline:
        config = PipelineConfig(
            target=JsBundle(
                links=[
                    Link(name="doc", url="dist/docs/index.html"),
                    Link(name="coverage", url="coverage/lcov-report/index.html"),
                    Link(name="bundle-analysis", url="dist/bundle-analysis.html"),
                ]
            )
        )
        return await pipeline(config, context)
